"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withHTML = void 0;

var _react = _interopRequireWildcard(require("react"));

var _addons = require("@storybook/addons");

var _server = require("react-dom/server");

var _styledComponents = require("styled-components");

var _shared = require("../shared");

var _2 = require(".");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Wrapper = function Wrapper(_ref) {
  var setCode = _ref.setCode,
      children = _ref.children;
  (0, _react.useEffect)(function () {
    var styleTags = '';
    var html = '';
    var sheet = new _styledComponents.ServerStyleSheet();

    try {
      html = (0, _server.renderToString)(sheet.collectStyles(children));
      styleTags = sheet.getStyleTags();
      console.log("Wrapper -> styleTags", styleTags);
    } catch (error) {
      // handle error
      console.error(error);
    } finally {
      sheet.seal();
    }

    setCode({
      html: html,
      css: styleTags
    });
  });
  return /*#__PURE__*/_react["default"].createElement("div", null, children);
};

var withHTML = (0, _addons.makeDecorator)(_objectSpread({}, _2.parameters, {
  wrapper: function wrapper(getStory, _, _ref2) {
    var _ref2$options = _ref2.options,
        options = _ref2$options === void 0 ? {} : _ref2$options;

    var channel = _addons.addons.getChannel();

    return /*#__PURE__*/_react["default"].createElement(Wrapper, {
      setCode: function setCode(_ref3) {
        var html = _ref3.html,
            css = _ref3.css;
        channel.emit(_shared.EVENT_CODE_RECEIVED, {
          html: html,
          css: css,
          options: options
        });
      }
    }, getStory());
  }
}));
exports.withHTML = withHTML;

if (module && module.hot && module.hot.decline) {
  module.hot.decline();
}